<template>
  <section>
    <div class="scroll-horiz">
    <div class="subjBackground">
      <h2>Overzicht van de gekozen vakken</h2>

      <div class="subj" v-if="isLoaded">
        <OneTrajectDetail v-for="(item, index) in trajectDetail.subjects" :key="'item'
                + index" :detail-data="item"></OneTrajectDetail>
<!--        <one-traject-detail v-for="subject in (trajectories[0])"-->
<!--                            :key="subject.id" :detail-data="subject"></one-traject-detail>-->
      </div>
    </div>

    <div class="btnNaastElkaar">
      <div class="btnRechts">
        <primary-btn value="Verwijderen" @click="deleteTraj" class="saptie"></primary-btn>
        <primary-btn value="Printen" @click="print" class="saptie"></primary-btn>
      </div>

      <div class="btnRechts" v-if="isLoaded">
        <div>
          <primary-btn
            v-if="trajectDetail.favorite === 0"
            value="Favoriete" @click="addToFavTraj" class="saptie">
          </primary-btn>
          <primary-btn
            v-else
            value="Niet favoriete" @click="remFromFavTraj" class="saptie">
          </primary-btn>
        </div>
        <div>
          <primary-btn
            v-if="trajectDetail.shared === 0" value="Delen" @click="shareTraj">
          </primary-btn>
          <primary-btn
            v-else value="Gedeeld" class="disabled">
          </primary-btn>
        </div>
      </div>
    </div>
    </div>
  </section>
  <div class="loading" v-show="loading" role="alert">
    <div class="loading-animate"></div>
  </div>
</template>

<script>
// import trajectDetail from '../../../dummy_data/trajectDetail';
import OneTrajectDetail from '../molecules/OneTrajectDetail.vue';
import PrimaryBtn from '../atoms/PrimaryBtn.vue';

export default {
  /* eslint-disable */
  name: 'TrajectDetail',
  components: { PrimaryBtn, OneTrajectDetail },
  data() {
    return {
      trajectId: this.$route.params.id,
      loading: false,
    };
  },
  computed: {
    trajectDetail() {
      const traj = this.$store.getters.trajectories.find(
        (trajectory) => trajectory.id === parseInt(this.trajectId, 10),
      );
      if (!traj) {
        // eslint-disable-next-line vue/no-side-effects-in-computed-properties
        this.$router.push({ name: 'Home' });
      }
      return traj;
    },
    load() {
      return this.$store.getters.trajectories;
    },
    isLoaded() {
      const data = this.load;
      return data.length !== 0;
    },
  },
  methods: {
    async deleteTraj() {
      // eslint-disable-next-line no-restricted-globals
      if (confirm('Wil je zeker de huidige traject verwijderen?')) {
        this.loading = true;
        try {
          await this.$store.dispatch('dlTrajectory', this.trajectId);
        } catch (errors) {
          console.log(errors);
        } finally {
          // eslint-disable-next-line max-len
          await this.$router.push({ name: 'Trajecten' });
        }
      }
    },
    async shareTraj() {
      // eslint-disable-next-line no-restricted-globals
      if (confirm('Wil je zeker de huidige traject delen?')) {
        this.loading = true;
        try {
          await this.$store.dispatch('shareTrajectory', this.trajectId);
        } catch (errors) {
          console.log(errors);
        } finally {
          // eslint-disable-next-line max-len
          await this.$router.go();
        }
      }
    },
    async addToFavTraj() {
      this.loading = true;
      try {
        await this.$store.dispatch('likeTrajectory', this.trajectId);
      } catch (errors) {
        console.log(errors);
      } finally {
        // eslint-disable-next-line max-len
        await this.$router.go();
      }
    },
    async remFromFavTraj() {
      this.loading = true;
      try {
        await this.$store.dispatch('unlikeTrajectory', this.trajectId);
      } catch (errors) {
        console.log(errors);
      } finally {
        // eslint-disable-next-line max-len
        await this.$router.go();
      }
    },
    print() {
      window.print();
    },
  },
  // props: ['id'],
};
</script>

<style scoped lang="scss">
section{
  padding-top: 10%;
}
.subjBackground{
  background-color: $my-white;
  width: 80%;
  margin: 0 auto 1% auto;
  border-radius: 11px;

  h2{
    font-size: 1.3em;
    padding: 50px 0 10px 0;
    border-bottom: $my-orange solid 1px;
    margin: 0 4% 2px 4%;
    line-height: 130%;
    font-family: $my-text;
    color: $my-orange;
  }

  .subj{
    display: flex;
    justify-content: space-around;
    flex-wrap: wrap;
    padding: 20px 50px 50px 50px;
  }
}
.btnNaastElkaar{
  width: 80%;
  margin: 3% auto;
  display: flex;
  justify-content: space-between;

  .btnRechts{
    display: flex;
    justify-content: space-between;
    flex-wrap: wrap;
  }
  .saptie{
    margin-right: 20px;
  }
  .disabled{
    background-color: gray;
  }
}
@media (max-width: 1100px){
  section{
    .subjBackground {
      width: 100%;
    }
    .btnNaastElkaar{
      width: 98%;
      .saptie{
        margin: 5px auto 0 auto;
      }
      .btnRechts{
        margin-top: 20px;
        margin-bottom: 20px;
      }
    }
  }
}
.loading-animate {
  border: 8px solid #f3f3f3;
  border-radius: 50%;
  border-top: 8px solid $my-blue;
  border-bottom: 8px solid $my-blue;
  width: 60px;
  height: 60px;
  -webkit-animation: spin 2s linear infinite;
  animation: spin 2s linear infinite;
}
.loading {
  display: flex;
  justify-content: center;
  align-items: center;
  position: fixed;
  z-index: 6;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}
</style>
